import java.util.*

fun match(g: Array<List<Int>>) : Boolean {
   val mt = IntArray(g.size) { -1 }
   val used = BooleanArray(g.size) { false }
   fun dfs(v:Int) : Boolean {
       if (used[v]) return false
       used[v] = true
       for (i in g[v]) {
           if (mt[i] == -1 || dfs(mt[i])) {
               mt[i] = v
               return true
           }
       }
       return false
   }
   return g.indices.all {
       Arrays.fill(used, false)
       dfs(it)
   }
}

fun main() {
    val (n, a, b) = readInts()
    val min = IntArray(n) { 0 }
    val max = IntArray(n) { n }
    val left = IntArray(n) { 0 }
    val right = IntArray(n) { n }

    repeat(a) {
        val (l, r, m) = readInts().map { it - 1 }
        for (i in l..r) min[i] = maxOf(min[i], m)
        left[m] = maxOf(left[m], l)
        right[m] = minOf(right[m], r)
    }
    repeat(b) {
        val (l, r, m) = readInts().map { it - 1 }
        for (i in l..r) max[i] = minOf(max[i], m)
        left[m] = maxOf(left[m], l)
        right[m] = minOf(right[m], r)
    }

    val g = Array(n) { i -> (0 until n).filter { j -> (j in left[i]..right[i]) && (i in min[j]..max[j]) }.sorted()}
    if (!match(g)) {
        return println(-1)
    }
    for (i in g.indices) {
        val nxt = g[i].first {
            g[i].let { backup ->
                g[i] = listOf(it)
                match(g).also { g[i] = backup }
            }
        }
        g[i] = listOf(nxt)
    }
    println(g.joinToString(" ") { (it[0]+1).toString() })
}

private fun readLn() = readLine()!!
private fun readInt() = readLn().toInt()
private fun readLongs() = readStrings().map { it.toLong() }
private fun readStrings() = readLn().split(" ")
private fun readInts() = readStrings().map { it.toInt() }