#include <cstdio>
#include <vector>
#include <cstring>
#include <algorithm>
#define CLR(x) memset(x,0,sizeof(x))
using namespace std;

const int N = 405, mod = 998244353;

int n, m, ans, inv[N], fa[N], dep[N], sz[N], vis[N], dis[N], dp[N][N];
vector<int> G[N];
vector<vector<int>> aug[N];

void link(int a, int b) {
    G[a].push_back(b);
    G[b].push_back(a);
}

void dfs(int u) {
    for (auto &v : G[u])
        if (v != fa[u]) {
            if (!dep[v]) {
                dep[v] = dep[u] + 1;
                fa[v] = u;
                dfs(v);
            } else if (dep[v] < dep[u]) {
                vector<int> bcc;

                for (int x = u, y = 0; x != v; x = fa[x])
                    bcc.push_back(x), dis[x] = ++y;

                aug[v].push_back(bcc);
            }
        }
}

void solve(int u) {
    vis[u] = 1;

    for (const auto &bcc : aug[u]) {
        int s = bcc.size();

        for (auto &p : bcc)
            vis[p] = 1, sz[p] = sz[u] + s;

        for (int j = 1; j <= sz[u]; ++j)
            if (dp[u][j])
                for (auto &p : bcc) {
                    (dp[p][j + dis[p]] += dp[u][j]) %= mod;
                    (dp[p][j + s + 1 - dis[p]] += dp[u][j]) %= mod;
                    (dp[p][j + s] -= dp[u][j]) %= mod;
                }

        for (auto &p : bcc)
            solve(p);
    }

    for (auto &p : G[u])
        if (!vis[p]) {
            sz[p] = sz[u] + 1;

            for (int j = 1; j <= sz[u]; ++j)
                dp[p][j + 1] = dp[u][j];

            solve(p);
        }
}

int main() {
    scanf("%d %d", &n, &m);

    for (int i = 1, a, b; i <= m; ++i)
        scanf("%d %d", &a, &b), link(a, b);

    inv[1] = 1;

    for (int i = 2; i <= n; ++i)
        inv[i] = 1LL * (mod - mod / i) * inv[mod % i] % mod;

    for (int i = 1; i <= n; ++i) {
        CLR(dp);
        CLR(fa);
        CLR(dep);
        CLR(sz);
        CLR(dis);
        CLR(vis);

        for (int j = 1; j <= n; ++j)
            vector<vector<int>>().swap(aug[j]);

        dep[i] = 1;
        dfs(i);
        dp[i][sz[i] = 1] = 1;
        solve(i);

        for (int j = 1; j <= n; ++j)
            for (int k = 1; k <= sz[j]; ++k)
                if (dp[j][k])
                    ans = (ans + 1LL * dp[j][k] * inv[k]) % mod;
    }

    printf("%d", (ans + mod) % mod);
    return 0;
}
