#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
int n, m, q, fa[100010][18], sz[100010], tmp, dfn[100010], cnt = 0, tot = 0, tree[2000010];
int lc[2000010], rc[2000010], rt[2000010], pos[100010], ans, bgdep[100010], head[100010], tot1 = 0;
ll dep[100010];
struct edge {
    int next, to;
} edge[200010];
struct node {
    int to, rt,l , r , fa ; 
} group [ 100010 ] ;

int read() {
    char ch = getchar();
    int sum = 0, f = 1;

    while (ch < '0' || ch > '9') {
        if (ch == '-')
            f = -1;

        ch = getchar();
    }

    while (ch >= '0' && ch <= '9') {
        sum = sum * 10 + ch - '0';
        ch = getchar();
    }

    return sum * f;
}

void dfs(int u, int p) {
    dfn[++cnt] = u;
    pos[u] = cnt;
    sz[u] = 1;
    fa[u][0] = p;
    dep[u] = dep[p] + 1;

    for (int i = 1; i <= 17; i++)
        fa[u][i] = fa[fa[u][i - 1]][i - 1];

    for (int i = head[u]; i; i = edge[i].next) {
        int v = edge[i].to;

        if (v != p) {
            dfs(v, u);
            sz[u] += sz[v];
        }
    }
}

int lca(int x, int y) {
    if (dep[x] < dep[y]) {
        tmp = x;
        x = y;
        y = tmp;
    }

    for (int i = 17; i >= 0; i--) {
        if (dep[fa[x][i]] >= dep[y])
            x = fa[x][i];

        if (x == y)
            return x;
    }

    for (int i = 17; i >= 0; i--)
        if (fa[x][i] != fa[y][i]) {
            x = fa[x][i];
            y = fa[y][i];
        }

    return fa [ x ] [ 0 ] ; 
}

void insert(int &root, int oroot, int l, int r, int p) {
    root = ++tot;
    tree[root] = tree[oroot] + 1;

    if (l == r)
        return ;

    int mid = (l + r) / 2;

    if (p <= mid) {
        insert(lc[root], lc[oroot], l, mid, p);
        rc[root] = rc[oroot];
    } else {
        insert(rc[root], rc[oroot], mid + 1, r, p);
        lc[root] = lc[oroot];
    }
}

int query(int lroot, int rroot, int l, int r, int k) {
    if (l == r)
        return l;

    int mid = (l + r) / 2;

    if (k <= tree[lc[rroot]] - tree[lc[lroot]])
        return query(lc[lroot], lc[rroot], l, mid, k);
    else {
        k -= tree[lc[rroot]] - tree[lc[lroot]];
        return query(rc[lroot], rc[rroot], mid + 1, r, k);
    }
}

int erfen(int r, int x) {
    int l = 1;

    while (l < r) {
        int mid = (l + r) >> 1;

        if (group[mid].l > x)
            r = mid;
        else if (group[mid].r < x)
            l = mid + 1;
        else
            return mid;
    }

    return l;
}

ll smalltree(int x, int gx) {
    int Left = pos[group[gx].rt], Right;
    Right = Left + sz[group[gx].rt] - 1;
    int a = query(rt[Left - 1], rt[Right], 1, n, x - group[gx - 1].r);
    return dep[a] - dep[group[gx].rt] + 1;
}

ll same(int x, int gx, int y, int gy) {

}

int solve(int x, int y) {
    ll ans = 0;
    int ex = erfen(m, x), ey = erfen(m, y);

    if (bgdep[ex] < bgdep[ey]) {
        tmp = x;
        x = y;
        y = tmp;
        tmp = ex;
        ex = ey;
        ey = tmp;
    }

    while (bgdep[ex] != bgdep[ey]) {
        ans += smalltree(x, ex);
        x = group[ex].to;
        ex = group[ex].fa;
    }

    while (ex != ey) {
        ans += smalltree(x, ex) + smalltree(y, ey);
        x = group[ex].to;
        y = group[ey].to;
        ex = group[ex].fa;
        ey = group[ ey ] . fa ; 
    }

    int Leftx = pos[group[ex].rt], Rightx;
    Rightx = Leftx + sz[group[ex].rt] - 1;
    int a = query(rt[Leftx - 1], rt[Rightx], 1, n, x - group[ex].l + 1);
    int Lefty = pos[group[ey].rt], Righty;
    Righty = Lefty + sz[group[ey].rt] - 1;
    int b = query(rt[Lefty - 1], rt[Righty], 1, n, y - group[ey].l + 1);
    int find = lca(a, b);
    ans += dep[a] + dep[b] - (dep[find] << 1);
    return ans;
}

int main() {
    n = read();
    m = read();
    q = read();

    for (int i = 1; i < n; i++) {
        int u, v;
        u = read();
        v = read();
        edge[++tot1].to = v;
        edge[tot1].next = head[u];
        head[u] = tot1;
        edge[++tot1].to = u;
        edge[tot1].next = head[v];
        head[v] = tot1;
    }

    m++;
    dfs(1, 0);
    group[1].rt = 1;
    group[1].l = 1;
    group[1].r = n;
    bgdep[1] = 1;

    for (int i = 2; i <= m; i++) {
        int x, to;
        x = read();
        to = read();
        group[i].to = to;
        group[i].rt = x;
        group[i].l = group[i - 1].r + 1;
        group[i].r = group[i].l + sz[x] - 1;
        group[i].fa = erfen(i, to);
        bgdep[i] = bgdep[group[ i ] . fa ]  +  1 ; 
    }

    rt [ 0 ]  =  0 ;

    for (int i = 1; i <= n; i++)
        insert(rt[i], rt[i - 1], 1, n, dfn[i]);

    while (q--) {
        int fr, to;
        scanf("%d%d", &fr, &to);
        printf("%d\n", solve(fr, to));
    }

    return 0;
}
