import java.util.*

fun isPrime(x: Int) = (2 until x).none { x % it == 0 }

fun main() {
    val (lim, cnt_) = readLongs()
    val cnt = cnt_.toInt()
    val primes = (2 until 128).filter(::isPrime)
    data class Gen(val maxId: Int, val value: Long, val baseP: Int) : Comparable<Gen> {
        override fun compareTo(other: Gen) = -value.compareTo(other.value)
    }
    val q = PriorityQueue<Gen>()
    for ((index, value) in primes.withIndex()) {
        var c = 1L
        while (lim / c >= value) {
            c *= value
            q.add(Gen(index - 1, c, value))
        }
    }
    repeat(cnt - 1) {
        val (maxId, value, baseP) = q.poll()
        if ((value / baseP) % baseP == 0L) {
            for (i in 0..maxId) {
                q.add(Gen(i, value / baseP * primes[i], baseP))
            }
        }
    }
    println(q.poll().value)
}

private fun readLn() = readLine()!!
private fun readInt() = readLn().toInt()
private fun readLongs() = readStrings().map { it.toLong() }
private fun readStrings() = readLn().split(" ")
private fun readInts() = readStrings().map { it.toInt() }