@file:OptIn(kotlin.ExperimentalStdlibApi::class)

class Solver25(val p: Int) {
    fun addLeft(x: Int) {
        size += 1
        if (x % p == 0) count += 1
        answer += count
    }

    fun removeLeft(x: Int) {
        answer -= count
        if (x % p == 0) count -= 1
        size -= 1
    }

    fun addRight(x: Int) {
        size += 1
        if (x % p == 0) {
            answer += size
            count += 1
        }
    }

    fun removeRight(x: Int) {
        if (x % p == 0) {
            count -= 1
            answer -= size
        }
        size -= 1
    }

    var answer = 0L
    var count = 0
    var size = 0
}

class SolverCoprime(C: Int) {
    val cnt = IntArray(C) { 0 }
    var answer = 0L

    fun add(x: Int) {
        val cur = cnt[x]
        answer += cur
        cnt[x] = cur + 1
    }

    fun remove(x: Int) {
        val cur = cnt[x]
        cnt[x] = cur - 1
        answer -= cur - 1
    }
}

data class Query(val l:Int, val r:Int, val index:Int)

fun solve25(s: IntArray, qs: List<Query>, p: Int) : LongArray {
    val solver = Solver25(p)
    val BS = kotlin.math.sqrt(s.size.toDouble()).toInt()
    val answer = LongArray(qs.size) { -1 }
    var curl = 0
    var curr = 0
    for ((l, r, index) in qs.sortedWith(compareBy({ it.l / BS }, { it.r }))) {
        while (curr < r) solver.addRight(s[curr++])
        while (curl > l) solver.addLeft(s[--curl])
        while (curr > r) solver.removeRight(s[--curr])
        while (curl < l) solver.removeLeft(s[curl++])
        answer[index] = solver.answer
    }
    return answer
}

fun solveCoprime(s: IntArray, qs: List<Query>, p: Int) : LongArray {
    val p10 = (0..s.size).runningFold(1) { acc, _ -> ((acc * 10L) % p).toInt() }.toIntArray()
    val ss_ = s.reversed()
        .runningFoldIndexed(0) { index, acc, value -> ((acc + value.toLong() * p10[index]) % p).toInt() }
        .reversed().toIntArray()
    val ssc = ss_.toSet().sorted()
    val ss = ss_.map { ssc.binarySearch(it) }.toIntArray()

    val solver = SolverCoprime(ss.size)

    val BS = kotlin.math.sqrt(s.size.toDouble()).toInt()
    val answer = LongArray(qs.size) { -1 }
    var curl = 0
    var curr = 0
    solver.add(ss[0])
    for ((l, r, index) in qs.sortedWith(compareBy({ it.l / BS }, { it.r }))) {
        while (curr < r) solver.add(ss[++curr])
        while (curl > l) solver.add(ss[--curl])
        while (curr > r) solver.remove(ss[curr--])
        while (curl < l) solver.remove(ss[curl++])
        answer[index] = solver.answer
    }
    return answer
}


fun main() {
    val p = readInt()
    val s = readLn().toCharArray().map { it.digitToInt() }.toIntArray()
    val q = readInt()
    val qs = List(q) { index -> readInts().let { Query(it[0] - 1, it[1], index) }}
    println(when (p) {
        2, 5 -> solve25(s, qs, p)
        else -> solveCoprime(s, qs, p)
    }.joinToString("\n"))
}

private fun readLn() = readLine()!!
private fun readInt() = readLn().toInt()
private fun readLongs() = readStrings().map { it.toLong() }
private fun readStrings() = readLn().split(" ")
private fun readInts() = readStrings().map { it.toInt() }