import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.math.BigInteger;
import java.util.Arrays;
import java.util.StringTokenizer;

public class G_sm {
    final long MOD = 998244353;
    final BigInteger BI_MOD = BigInteger.valueOf(MOD);
    final int MAXN = 100000;

    private int[] bits;
    private int[] cnt1;
    long[] fact = new long[MAXN + 1];
    long[] invfact = new long[MAXN + 1];

    void solve() {
        fact[0] = invfact[0] = fact[1] = invfact[1] = 1;
        for (int i = 2; i < fact.length; i++) {
            fact[i] = (fact[i - 1] * i) % MOD;
            invfact[i] = BigInteger.valueOf(fact[i]).modInverse(BI_MOD).longValue();
        }
        String s = next();
        int k = nextInt();
        bits = new int[s.length() * 4];
        cnt1 = new int[s.length() * 4];
        int it = 0;
        int c1 = 0;

        for (char c : s.toCharArray()) {
            int X;
            if (c <= '9') {
                X = c - '0';
            } else {
                X = c - 'A' + 10;
            }
            for (int i = 3; i >= 0; i--) {
                c1 += bits[it] = ((X & (1 << i)) > 0) ? 1 : 0;
                cnt1[it] = c1;
                it++;
            }
        }
        System.err.println(Arrays.toString(bits));
        System.err.println(Arrays.toString(cnt1));
        out.println(count(0, k));
    }

    long choose(int n, int k) {
        if (k < 0 || k > n) {
            return 0;
        }
        System.err.println(n + " " + k);
        return ((fact[n] * invfact[k]) % MOD * invfact[n - k]) % MOD;
    }

    long count(int pos, int k) {
        if (pos == bits.length) {
            if (k == 0) {
                return 1;
            } else {
                return 0;
            }
        }
        if (bits[pos] == 1) {
            return (choose(bits.length - pos - 1, k) + count(pos + 1, k - 1)) % MOD;
        } else {
            return count(pos + 1, k);
        }
    }


    BufferedReader br;
    StringTokenizer st;
    PrintWriter out;

    String next() {
        while (st == null || !st.hasMoreTokens()) {
            try {
                st = new StringTokenizer(br.readLine());
            } catch (IOException e) {
                e.printStackTrace();
                System.exit(1);
            }
        }
        return st.nextToken();
    }

    int nextInt() {
        return Integer.parseInt(next());
    }

    void run() {
        br = new BufferedReader(new InputStreamReader(System.in));
        out = new PrintWriter(System.out);
        solve();
        out.close();
    }

    public static void main(String[] args) {
        new G_sm().run();
    }
}
