// Created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
#ifdef LOCAL
	mt19937 tw(9450189);
#else
	mt19937 tw(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }

int get_hex_dig(char c) {
	if ('0' <= c && c <= '9') {
		return c - '0';
	}
	return c - 'A' + 10;
}

const int MOD = 998244353;

void add(int& a, int b) {
	a += b;
	if (a >= MOD) {
		a -= MOD;
	}
}

int sum(int a, int b) {
	add(a, b);
	return a;
}

int mult(int a, int b) {
	return (ll) a * b % MOD;
}

int mpow(int a, int b) {
	int ret = 1;
	while (b) {
		if (b & 1) {
			ret = mult(ret, a);
		}
		a = mult(a, a);
		b /= 2;
	}
	return ret;
}

int inv(int a) {
	return mpow(a, MOD - 2);
}

vector<int> factorial, inv_factorial;

int cnk(int n, int k) {
	return mult(factorial[n], mult(inv_factorial[k], inv_factorial[n - k]));
}

void solve() {
	vector<bool> n;
	string s;
	cin >> s;
	for (char c : s) {
		int d = get_hex_dig(c);
		for (int i = 3; i >= 0; --i) {
			n.push_back((d >> i) & 1);
		}
	}

	reverse(n.begin(), n.end());
	while (szof(n) && n.back() == 0) {
		n.pop_back();
	}

	factorial.push_back(1);
	for (int i = 1; i <= szof(n) + 5; ++i) {
		factorial.push_back(mult(factorial.back(), i));
	}

	inv_factorial.push_back(inv(factorial.back()));
	for (int i = szof(n) + 5; i >= 1; --i) {
		inv_factorial.push_back(mult(inv_factorial.back(), i));
	}

	reverse(inv_factorial.begin(), inv_factorial.end());

	int k;
	cin >> k;

	int ans = 0;

	reverse(n.begin(), n.end());
	int cnt = 0;
	for (int i = 0; i < szof(n); ++i) {
		if (n[i] == 1) {
			if (cnt <= k && szof(n) - i - 1 + cnt >= k) {
				add(ans, cnk(szof(n) - i - 1, k - cnt));
			}
		}

		cnt += n[i];
	}

	if (cnt == k) {
		add(ans, 1);
	}

	cout << ans << "\n";
}


int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int test_count = 1;
	// cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}

#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}