#include "testlib.h"

using namespace std;

vector <int> powers[28];

void prepare_data ()
{
 long long res;
 int pw;
 for (int i=2;i*i<1000000000;i++)
  {
     pw=0;
     res=i*i;
     while (res<=1000000000LL)
      {
       powers[pw].push_back(res);;
       pw++;
       res*=i;
      }
  }
}

int testID=3;
int data[1000010];

int write_test (int n, int *a)
{
 char fn[10];
 sprintf (fn,"%03d",testID++);
 FILE *st1=fopen (fn,"w");
 fprintf (st1,"%d\n",n);
 shuffle (a,a+n);
 for (int i=0;i<n;i++)
   fprintf (st1,"%d%c",a[i],(i<n-1)?' ':'\n');
 fclose (st1);
 return 0;
}

int gen_max_no (int n)
{
 for (int i=0;i<n;i++) 
  data[i]=999999999;
 write_test (n,data);
} 

void gen_all_squares (int n)
{
  int l=powers[0].size();
  for (int i=0;i<n;i++)
   data[i]=powers[0][rnd.next(0,l-1)];
  write_test (n,data);
}

void gen_random (int n)
{
 for (int i=0;i<n;i++) 
  data[i]=rnd.next (2,1000000000);
 write_test (n,data);
}

void gen_all_maxpow (int n)
{
  for (int i=0;i<n;i++)
   data[i]=(1<<29);
  write_test (n,data);
}

void gen_all_diff_powers (int n)
{
  int k,l;
  for (int i=0;i<n;i++)
   {
     k=rnd.next (2,29)-2;
     l=rnd.next (0,(int)powers[k].size()-1);
     data[i]=powers[k][l];
   }
  write_test (n,data);
}

void gen_mixed (int n)
{
  int k,l;
  for (int i=0;i<n;i++)
   {
     if (rnd.next (0,1))
      {
       k=rnd.next (2,29)-2;
       l=rnd.next (0,(int)powers[k].size()-1);
       data[i]=powers[k][l];
      }
     else
     data[i]=rnd.next(2,1000000000);
   }
  write_test (n,data);
}

int main (int argc, char **argv)
{
 registerGen (argc,argv,1);
 prepare_data();

 for (int i=10;i<=10000;i*=10)
  {
   gen_max_no(i);
   gen_all_squares (i);
   gen_all_maxpow (i);
   gen_random (i);
   gen_all_diff_powers (i);
   gen_mixed (i);
   gen_mixed (i);
  }

 return 0;
}