#include <cstdio>
#include <vector>
#include <cstdlib>
#include <algorithm>

using namespace std;

int played[10][10];
int backup[10][10];

vector <int> gms;

void clear_played ()
{
 for (int i=0;i<10;i++)
  for (int j=0;j<10;j++)
     played[i][j] = (i==j) ? 1 : 0;
}

void save_played ()
{
 for (int i=0;i<10;i++)
  for (int j=0;j<10;j++)
     backup[i][j] = played[i][j];
}

void restore_played ()
{
 for (int i=0;i<10;i++)
  for (int j=0;j<10;j++)
     played[i][j] = backup[i][j];
}


void init_triples ()
{
   for (int i=0;i<9;i++)
    for (int j=0;j<i;j++)
     for (int k=0;k<j;k++)
        gms.push_back ( (1<<i) + (1<<j) + (1<<k) );
}

void decode_mask (int mask, int *arr)
{
  int j=0;
  for (int i=0;(i<9)&&(j<3);i++)
   {
     if (mask&1) arr[j++]=i+1;
     mask>>=1;
   }
}

int encode_mask (int x, int y, int z)
{
   return (1<<(x-1)) + (1<<(y-1)) + (1<<(z-1));
}

bool check_mask (int mask)
{
  int a[3];
  decode_mask (mask,a);
  for (int i=0;i<3;i++)
   if (played[a[i]][a[(i+1)%3]]) return false;
  return true;
}

void apply_mask (int mask)
{
  int a[3];
  decode_mask (mask,a);
  for (int i=0;i<3;i++)
   played[a[i]][a[(i+1)%3]]=played[a[(i+1)%3]][a[i]]=1;
}


int main ()
{
 int ng,a[3],mask;
 scanf ("%d",&ng);
 
 init_triples();
 clear_played();
 
 for (int i=0;i<ng;i++)
  {
   scanf ("%d%d%d",a,a+1,a+2);
   mask=encode_mask (a[0],a[1],a[2]);
   if (check_mask (mask))
    apply_mask (mask);
   else 
    {
     printf ("-1\n");
     return 0;
    }
   }

 save_played();

 for (int times=0;times<1000;times++)
  {
   vector <int> res;
   random_shuffle (gms.begin(),gms.end());
   restore_played ();
   for (int i=0;i<gms.size();i++)
    {
     if (check_mask(gms[i]))
      {
       res.push_back (gms[i]);
       apply_mask (gms[i]);
      }
     } 
//    fprintf (stderr, "%d\n", ng+res.size());
    if (ng+res.size()==12)
     {
       printf ("%d\n",res.size());
       for (int i=0;i<res.size();i++)
        {
         decode_mask (res[i],a);
         printf ("%d %d %d\n",a[0],a[1],a[2]);
        }
       fprintf (stderr,"%d\n",times);
       return 0;
     }
   }
   printf ("-1\n");
   return 0;
}
