#include "testlib.h"

using namespace std;

int testID=2;
int data[100010];

int write_test (int n, int *a)
{
 char fn[10];
 sprintf (fn,"%03d",testID++);
 FILE *st1=fopen (fn,"w");
 fprintf (st1,"%d\n",n);
 shuffle (a,a+n);
 for (int i=0;i<n;i++)
   fprintf (st1,"%d\n",a[i]);
 fclose (st1);
 return 0;
}

void gen_all_max (int n)
{
 for (int i=0;i<n;i++) 
  data[i]=1000000000;
 write_test (n,data);
} 

void gen_all_min (int n)
{
 for (int i=0;i<n;i++) 
  data[i]=-1000000000;
 write_test (n,data);
} 

void gen_all_zero (int n)
{
 for (int i=0;i<n;i++) 
  data[i]=0;
 write_test (n,data);
} 


void gen_rand_neg (int n)
{
 for (int i=0;i<n;i++) 
  data[i]=rnd.next (-1000000000,-1);
 write_test (n,data);
} 

void gen_rand_zneg (int n)
{
 data[0]=0;
 for (int i=1;i<n;i++) 
  data[i]=rnd.next (-1000000000,-1);
 write_test (n,data);
} 


void gen_rand_pos (int n)
{
 for (int i=0;i<n;i++) 
  data[i]=rnd.next (1,1000000000);
 write_test (n,data);
} 

void gen_rand (int n)
{
 for (int i=0;i<n;i++) 
  data[i]=rnd.next (-1000000000,1000000000);
 write_test (n,data);
}

void gen_rand_special (int n)
{
 int i;
 for (i=0;i*i<rnd.next(n/2,n);i++)
  data[i]=rnd.next(1,1000000000);
 for (;i<n;i++)
  data[i]=rnd.next (-1000000000,0);
 write_test (n,data);
}

int main (int argc, char **argv)
{
 registerGen (argc,argv,1);

 for (int i=10;i<=100000;i*=10)
  {
   gen_all_max(i);
   gen_all_min (i);
   gen_all_zero (i);
   gen_rand_neg (i);
   gen_rand_zneg (i);
   gen_rand_pos (i);
   gen_rand (i);
   gen_rand (i);
   gen_rand_special (i);
   gen_rand_special (i);
  }

 return 0;
}